Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1289)
@@ -45,4 +45,7 @@
     mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
 
+
+
+
     int num_color = 0;
 
@@ -56,6 +59,6 @@
     vector<int> all_color_loc(num_ep);
 
-    MPI_Gather_local(&color, 1, MPI_INT, all_color_loc.data(), 0, comm);
-    MPI_Bcast_local(all_color_loc.data(), num_ep, MPI_INT, 0, comm);
+    MPI_Gather_local2(&color, 1, MPI_INT, all_color_loc.data(), comm);
+    MPI_Bcast_local2(all_color_loc.data(), num_ep, MPI_INT, comm);
 
 
@@ -97,6 +100,6 @@
     vector<int> key_loc(num_ep);
 
-    MPI_Gather_local(&key, 1, MPI_INT, key_loc.data(), 0, comm);
-    MPI_Bcast_local(key_loc.data(), num_ep, MPI_INT, 0, comm);
+    MPI_Gather_local2(&key, 1, MPI_INT, key_loc.data(), comm);
+    MPI_Bcast_local2(key_loc.data(), num_ep, MPI_INT, comm);
 
     for(int i=0; i<num_ep; i++)
@@ -164,4 +167,5 @@
       {
         *newcomm = comm.ep_comm_ptr->comm_list->mem_bridge[new_ep_rank_loc];
+ //       newcomm = &(comm.ep_comm_ptr->comm_list->mem_bridge[new_ep_rank_loc]);
         (*newcomm).ep_comm_ptr->comm_label = color;
       }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1289)
@@ -24,6 +24,7 @@
     if(request->type == 1)      // isend
     {
+      ::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
       ::MPI_Status mpi_status;
-      ::MPI_Test(&(request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(&mpi_request, flag, &mpi_status);
       
       if(*flag) 
@@ -48,7 +49,8 @@
     if(request->type == 3)  // imrecv
     {
+      ::MPI_Request *mpi_request = static_cast< ::MPI_Request* >(&(request->mpi_request));
       ::MPI_Status mpi_status;
       
-      ::MPI_Test(&(request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(mpi_request, flag, &mpi_status);
       
       
@@ -66,5 +68,5 @@
       return 0;
     }
-
+		
   }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1289)
@@ -248,4 +248,10 @@
   struct BUFFER
   {
+    double *buf_double;
+    float  *buf_float;
+    int    *buf_int;
+    long    *buf_long;
+    unsigned long    *buf_ulong;
+    char    *buf_char;
     void * void_buffer[12];
   };
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1289)
@@ -18,5 +18,5 @@
 
 namespace ep_lib 
-{
+{	
   
   int MPI_Wait(MPI_Request *request, MPI_Status *status)
@@ -32,7 +32,9 @@
 
 
+    ::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
     ::MPI_Status mpi_status;
-    ::MPI_Wait(&(request->mpi_request), &mpi_status);
+    ::MPI_Wait(&mpi_request, &mpi_status);
       
+    request->mpi_request = mpi_request;
 
     status->mpi_status = &mpi_status;
